#include <windows.h>
#include <commctrl.h>
#include <tchar.h>
#include "resource.h"

#pragma comment(lib,"comctl32.lib")

#define IMAGE_WIDTH 120	//	1̉摜̉
#define IMAGE_HIGHT  80	//	1̉摜̍


TCHAR* szClassName=TEXT("C[WXg");
HINSTANCE hInst;

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
	TCHAR* lpszCmdLine, int nCmdShow){
	HWND hWnd;
	MSG lpMsg;
	WNDCLASS myProg;
	hInst=hInstance;

	if (!hPreInst) {
		myProg.style =CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc        =WndProc;
		myProg.cbClsExtra   =0;
		myProg.cbWndExtra        =0;
		myProg.hInstance        =hInstance;
		myProg.hIcon            =NULL;
		myProg.hCursor            =LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground = (HBRUSH__ *)GetStockObject(/*GRAY_BRUSH*/ WHITE_BRUSH);
		myProg.lpszMenuName        =NULL;
		myProg.lpszClassName    =szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	hWnd = CreateWindow(szClassName,
		TEXT("C[WXg"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL);
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	while (GetMessage(&lpMsg, NULL, 0, 0)) {
		TranslateMessage(&lpMsg);
		DispatchMessage(&lpMsg);
	}
	return int(lpMsg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
	static HIMAGELIST hImg;
	static HBITMAP hbitmap;
	static HDC img_hdc;
	HDC hdc;
    PAINTSTRUCT ps;

	HBRUSH hBrush, hOldBrush;
	BITMAPINFO bmp;

	switch(msg){
	case WM_CREATE:
//	C[WXg쐬
		hImg = ImageList_Create(IMAGE_WIDTH , IMAGE_HIGHT , ILC_COLOR32 | ILC_MASK, 3 , 0);

		hdc=GetDC(hWnd);
//	\[X摜ǂݍ݃C[WXgɓo^
		hbitmap=LoadBitmap(hInst,MAKEINTRESOURCE(IRELAND_BMP));
		ImageList_AddMasked(hImg ,hbitmap,RGB(255,255,255));
		DeleteObject(hbitmap);
//	\[X摜ǂݍ݃C[WXgɓo^
		hbitmap=LoadBitmap(hInst,MAKEINTRESOURCE(USA_BMP));
		ImageList_AddMasked(hImg ,hbitmap,RGB(255,255,255));
		DeleteObject(hbitmap);

//	̊ۂ쐬
//	ɃfoCXƗrbg}bv(DIB)쐬B
		ZeroMemory(&bmp,sizeof(bmp));
		bmp.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bmp.bmiHeader.biBitCount=32;
		bmp.bmiHeader.biPlanes=1;
		bmp.bmiHeader.biWidth=IMAGE_WIDTH;
		bmp.bmiHeader.biHeight=-IMAGE_HIGHT;
		hbitmap=CreateDIBSection(NULL,&bmp,DIB_RGB_COLORS,NULL , NULL,0);
//	ʂƌ݊̂foCXReLXg쐬
		img_hdc=CreateCompatibleDC(hdc);
		SelectObject(img_hdc , hbitmap);
		ReleaseDC(hWnd,hdc);

		HPEN hPen,hOldPen;
		hPen=CreatePen(PS_SOLID, 2, RGB(255,255,255) );
		hOldPen=(HPEN__ *)SelectObject(img_hdc, hPen);

		hBrush =CreateSolidBrush(RGB(255,255,255));
		hOldBrush = (HBRUSH__ *)SelectObject(img_hdc, hBrush);

		Rectangle(img_hdc , 0,0,IMAGE_WIDTH-1,IMAGE_HIGHT-1);

		hPen=CreatePen(PS_SOLID, 2, RGB(255,0,0) );
		SelectObject(img_hdc, hPen);

		hBrush =CreateSolidBrush(RGB(255,0,0));
		SelectObject(img_hdc, hBrush);

		Ellipse(img_hdc,IMAGE_WIDTH/2-16,IMAGE_HIGHT/2-16,IMAGE_WIDTH/2+16,IMAGE_HIGHT/2+16);
		SelectObject(img_hdc, hOldBrush);
		DeleteObject(hBrush);
		SelectObject(img_hdc, hOldPen);
		DeleteObject(hPen);
// C[WXgɓo^OɃfoCXReLXg폜Ȃ΂ȂȂ
//	폜ȂƐ^ȉ摜\邾łB
		DeleteDC(img_hdc);
		ImageList_AddMasked(hImg ,hbitmap,RGB(255,255,255));
		DeleteObject(hbitmap);
		break;
	case WM_PAINT:	//	ĕ`掞ɌĂяo
		hdc=BeginPaint(hWnd,&ps);
		ImageList_Draw(hImg , 0 , hdc ,0,0, ILD_NORMAL);
		ImageList_Draw(hImg , 1 , hdc , IMAGE_WIDTH , 0 , ILD_NORMAL);
		ImageList_Draw(hImg , 2 , hdc , IMAGE_WIDTH*2 , 0 , ILD_NORMAL);
		EndPaint(hWnd,&ps);
		break;
    case WM_DESTROY:	//	IɌĂяo
		ImageList_Destroy(hImg);
        PostQuitMessage(0);
        break;
    default:
		return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}
